import 'package:json_annotation/json_annotation.dart';
import 'package:minecraft_yggdrasil/src/scheme/common.dart';

part 'authenticate.g.dart';

@JsonSerializable()
class AuthenticateRequest {
  final Agent agent;
  final String username, password;
  final String? clientToken;
  final bool? requestUser;

  AuthenticateRequest({
    this.agent = const Agent(),
    required this.username,
    required this.password,
    this.clientToken,
    this.requestUser = true,
  });

  factory AuthenticateRequest.fromJson(Map<String, dynamic> json) =>
      _$AuthenticateRequestFromJson(json);

  Map<String, dynamic> toJson() => _$AuthenticateRequestToJson(this);
}

@JsonSerializable()
class AuthenticateResponse {
  final User user;
  final String clientToken, accessToken;
  final List<Profile> availableProfiles;
  final Profile selectedProfile;

  AuthenticateResponse({
    required this.user,
    required this.clientToken,
    required this.accessToken,
    required this.availableProfiles,
    required this.selectedProfile,
  });
  factory AuthenticateResponse.fromJson(Map<String, dynamic> json) =>
      _$AuthenticateResponseFromJson(json);
  Map<String, dynamic> toJson() => _$AuthenticateResponseToJson(this);
}
