import 'package:json_annotation/json_annotation.dart';

part 'common.g.dart';

@JsonSerializable()
class User {
  final String username, id;
  final List<Property>? properties;

  User({
    required this.username,
    required this.id,
    this.properties,
  });
  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);
  Map<String, dynamic> toJson() => _$UserToJson(this);
}

@JsonSerializable()
class Property {
  final String name, value;

  Property({
    required this.name,
    required this.value,
  });
  factory Property.fromJson(Map<String, dynamic> json) =>
      _$PropertyFromJson(json);
  Map<String, dynamic> toJson() => _$PropertyToJson(this);
}

@JsonSerializable()
class Profile {
  final String name, id;

  Profile({
    required this.name,
    required this.id,
  });
  factory Profile.fromJson(Map<String, dynamic> json) =>
      _$ProfileFromJson(json);
  Map<String, dynamic> toJson() => _$ProfileToJson(this);
}

@JsonSerializable()
class Agent {
  final String? name;
  final int version;

  const Agent({
    this.name = "Minecraft",
    this.version = 1,
  });
  factory Agent.fromJson(Map<String, dynamic> json) => _$AgentFromJson(json);
  Map<String, dynamic> toJson() => _$AgentToJson(this);
}
