// ignore_for_file: constant_identifier_names

import 'package:json_annotation/json_annotation.dart';

part 'errors.g.dart';

enum ErrorTypes {
  MethodNotAllowed,
  NotFound,
  ForbiddenOperationException,
  IllegalArgumentException,
  UnsupportedMediaType,
  ResourceException,
  GoneException,
  Unknown,
}

@JsonSerializable()
class ErrorResponse {
  final String error, errorMessage;
  final String? cause;

  const ErrorResponse({
    required this.error,
    required this.errorMessage,
    this.cause,
  });
  factory ErrorResponse.fromJson(Map<String, dynamic> json) =>
      _$ErrorResponseFromJson(json);
  Map<String, dynamic> toJson() => _$ErrorResponseToJson(this);
}

ErrorTypes lookUpErrorType(ErrorResponse arg) {
  var t = arg.error.replaceAll(" ", "");
  switch (t) {
    case "MethodNotAllowed":
      return ErrorTypes.ForbiddenOperationException;
    case "NotFound":
      return ErrorTypes.NotFound;
    case "ForbiddenOperationException":
      return ErrorTypes.ForbiddenOperationException;
    case "IllegalArgumentException":
      return ErrorTypes.IllegalArgumentException;
    case "UnsupportedMediaType":
      return ErrorTypes.UnsupportedMediaType;
    case "ResourceException":
      return ErrorTypes.ResourceException;
    case "GoneException":
      return ErrorTypes.GoneException;
    default:
      return ErrorTypes.Unknown;
  }
}
